//	Button.cpp : Defines the initialization routines for the DLL and the exported functions
//		High Tech BASIC, Copyright (C) TransEra Corp 1999, All Rights Reserved.

#include "stdafx.h"
#include "Button.h"
#include "ButtonDlg.h"
#include "DialogThread.h"
#include "assert.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CButtonApp

BEGIN_MESSAGE_MAP(CButtonApp, CWinApp)
	//{{AFX_MSG_MAP(CButtonApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CButtonApp construction

CButtonApp::CButtonApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CButtonApp object

CButtonApp theApp;


//****************************************************************************************************
// begin global variables -- used to communicate between threads and different instances of classes


ButtonDlg * g_pBtnDlg = NULL;			// global pointer to button dialog used for setting focus and closing
short g_BtnCount;								// the number of buttons desired
long g_Width;									// width of the dialog box
OPTION g_Option;								// 1 for modal, 2 for threaded variable update, 3 for threaded with signals
CString g_Title;								// Window title
CString	g_Description;							// Text above buttons will wrap to two lines if too long
CString	g_Text[10];								// button text
short * g_pPress;								// pointer into HTBasic memory for updateing user input


//	end global variables
//***************************************************************************************************
//  begin global functions not exported


// Initialize is used to set the member variables of a ButtonDlg instance to
// the settings saved from the user input.  Globals were used because this
// function might be called from the main thread or the spawned thread.

//void Initialize(ButtonDlg * Bdlg)
//{	Bdlg->g_BtnCount = g_BtnCount;
//	Bdlg->g_Width = g_Width;
//	Bdlg->m_option = g_Option;
//	Bdlg->m_sTitle = g_Title;
//	Bdlg->m_sStaticText = g_Text0;
//	Bdlg->m_sBtnText[0] = g_Text1;
//	Bdlg->m_sBtnText[1] = g_Text2;
//	Bdlg->m_sBtnText[2] = g_Text3;
//	Bdlg->m_sBtnText[3] = g_Text4;
//	Bdlg->m_sBtnText[4] = g_Text5;
//	Bdlg->m_sBtnText[5] = g_Text6;
//	Bdlg->m_sBtnText[6] = g_Text7;
//	Bdlg->m_sBtnText[7] = g_Text8;
//	Bdlg->m_sBtnText[8] = g_Text9;
//	Bdlg->m_sBtnText[9] = g_Text10;
//	Bdlg->m_pPress = g_Press;
//	g_pBtnDlg = Bdlg;							// save pointer to dialog so we can get to it later no matter what thread.

//}


// end global functions not exported
//*****************************************************************************************************
// begin exported functions


// Showbutton is the main function for setting up and displaying the button dialog box.  
//	Params:
//		option is a value between 1 and MAXOPTION.  a 1 will call a modal dialog box suspending Program execution and returning
//				the number of the button pushed or a zero if the dialog is closed with no button push.
//		count is the number of buttons from 0 to MAXBUTTON
//		width is the desired width of the dialog window and buttons
//		title is the text for the window title
//		description is the text that will appear above the buttons
//		text1 - text10 is the button text
//		press is a pointer to a short in Basic memory used as an alternative for the return value.

short Showbutton(short option,short count,long width,char * title,char * description,char * text1,char * text2,char * text3
			 ,char * text4,char * text5,char * text6,char * text7,char * text8,char * text9,char * text10,short * press)
{	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	long result = 0;

	if (g_pBtnDlg != NULL)						// Button dialog already active
	{	return((short)result);
	}

	if (count < 0 || count > MAXBUTTON)
	{	g_BtnCount = 0;							// default to 0 buttons for bad input
	}
	else
	{	g_BtnCount = count;						// save number of buttons
	}

	g_Width = width;							// save width

	if (option < 1 || option > MAXOPTION)
	{	g_Option = modal;						// default to modal for bad input
	}
	else
	{	g_Option = (OPTION)(option);			// 1 = modal  
	}											// 2 = threaded with variable
												// 3 = threaded with signal


	g_Title = title;
	g_Description = description;
	g_Text[0] = text1;
	g_Text[1] = text2;
	g_Text[2] = text3;
	g_Text[3] = text4;
	g_Text[4] = text5;
	g_Text[5] = text6;
	g_Text[6] = text7;
	g_Text[7] = text8;
	g_Text[8] = text9;
	g_Text[9] = text10;

	g_pPress = press;							// save pointer to press
	
	switch (g_Option)
	{	case modal:
		{	ButtonDlg Btn;						// create dialog object
//			Initialize(&Btn);					// set member functions to user specified values
			g_pBtnDlg = &Btn;
			result = Btn.DoModal();	
			g_pBtnDlg = NULL;					// reset pointer to dialog
			break;
		}
		
		case variable:
		case signal:
		{	CWinThread * pThread = AfxBeginThread(RUNTIME_CLASS (DialogThread));	// create thread to execute dialog
			result = 1;
			break;
		}

		default:
			assert(0);
			break;
	}

	return((short)result);
}


// end Showbutton
//*****************************************************************************************
// Setfocus -- used to bring the button dialog box to the foreground and activate.


void Setfocus()
{	if (g_pBtnDlg != NULL)
	{	SetForegroundWindow(g_pBtnDlg->m_hWnd);		// bring window to foreground and activate
	}
}


// end Setfocus
//*****************************************************************************************
// Closebutton -- Used to close button dialog box when running in its own thread.


void Closebutton()
{	if (g_pBtnDlg != NULL)
	{	g_pBtnDlg->KillTimer(1);				// stop timer from updating dialog
		g_pBtnDlg->EndDialog(0);				// close dialog and allow spawned thread to run out
		g_pBtnDlg = NULL;						// reset pointer to dialog
		//Sleep(0);								// This line allows the thread to shut down before Basic regains control
	}
}


// end Closebutton
//*****************************************************************************************
