// ToolBarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HTBToolbar.h"
#include "ToolBarDlg.h"
#include "export.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ToolBarDlg dialog


ToolBarDlg::ToolBarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ToolBarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ToolBarDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void ToolBarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ToolBarDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ToolBarDlg, CDialog)
	//{{AFX_MSG_MAP(ToolBarDlg)
	ON_COMMAND(ID_PRINTER, OnDumpit)
	ON_COMMAND(ID_SAVE, OnSavefile)
	ON_COMMAND(ID_ERASE, OnErase)
	ON_COMMAND(ID_NEW, OnNewpad)
	ON_COMMAND(ID_RED, OnRed)
	ON_COMMAND(ID_BLUE, OnBlue)
	ON_COMMAND(ID_YELLOW, OnYellow)
	ON_COMMAND(ID_PURPLE, OnPurple)
	ON_COMMAND(ID_WHITE, OnWhite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ToolBarDlg message handlers

BOOL ToolBarDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Create the Toolbar
	CreateToolBar();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/*************************************************************************
**************************************************************************
**																		**
**			Name:		 SetupImages									**
**																		**
**			Parameters:  CImageList*									**
**																		**
**		    Description: Adds the Button Icons to the CImageList		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
BOOL ToolBarDlg::SetupImages(CImageList* mImageList)
{
	CWinApp* pApp = AfxGetApp();
	mImageList->Create(24, 24, ILC_COLOR8 | ILC_MASK,  9, 9);
	mImageList->Add(pApp->LoadIcon(IDI_ICON1));
	mImageList->Add(pApp->LoadIcon(IDI_ICON2));
	mImageList->Add(pApp->LoadIcon(IDI_ICON3));
	mImageList->Add(pApp->LoadIcon(IDI_ICON4));
	mImageList->Add(pApp->LoadIcon(IDI_ICON5));
	mImageList->Add(pApp->LoadIcon(IDI_ICON6));
	mImageList->Add(pApp->LoadIcon(IDI_ICON7));
	mImageList->Add(pApp->LoadIcon(IDI_ICON8));
	mImageList->Add(pApp->LoadIcon(IDI_ICON9));

	return TRUE;
}

/*************************************************************************
**************************************************************************
**																		**
**			Name:		 CreateFlatToolBar								**
**																		**
**			Parameters:  None   										**
**																		**
**		    Description: Creates the Toolbar using the CImageList		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::CreateToolBar()
{

	// Setup the Image list
	SetupImages(&m_pImageList);

	TBBUTTON tb;

	// Create the Toolbar
	m_ToolBar.Create(WS_CHILD|WS_VISIBLE|WS_BORDER | CCS_NORESIZE, CRect(0,0,400,100), this, 0);

	// Setup the image list to be used for the toolbar
	m_ToolBar.SetImageList(&m_pImageList);

	// Toolbar Button #1
	tb.iBitmap = 0;
	tb.iString = NULL;
	tb.fsState = TBSTATE_ENABLED;
	tb.fsStyle = TBSTYLE_BUTTON;
	tb.idCommand = ID_PRINTER;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #2
	tb.iBitmap = 1;
	tb.idCommand = ID_NEW;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #3
	tb.iBitmap = 2;
	tb.idCommand = ID_SAVE;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #4
	tb.iBitmap = 3;
	tb.idCommand = ID_ERASE;
	tb.iString = NULL;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #5
	tb.iBitmap = 4;
	tb.idCommand = ID_RED;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #6
	tb.iBitmap = 5;
	tb.idCommand = ID_BLUE;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #7
	tb.iBitmap = 6;
	tb.idCommand = ID_YELLOW;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #8
	tb.iBitmap = 7;
	tb.idCommand = ID_PURPLE;
	m_ToolBar.AddButtons(1, &tb);

	// Toolbar Button #9
	tb.iBitmap = 8;
	tb.idCommand = ID_WHITE;
	m_ToolBar.AddButtons(1, &tb);


}


/*************************************************************************
**************************************************************************
**																		**
**			Name:		 OnDumpit										**
**																		**
**			Parameters:  None  								   	        **
**																		**
**		    Description: Signals the Print Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnDumpit()
{
	Signal(1);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name:		 OnSavefile										**
**																		**
**			Parameters:  None  								   	        **
**																		**
**		    Description: Signals the SaveAs Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnSavefile()
{
	Signal(3);	
}


/*************************************************************************
**************************************************************************
**																		**
**			Name:		 OnNewpad										**
**																		**
**			Parameters:  None  								   	        **
**																		**
**		    Description: Signals the New Routine in HTBasic    		    **
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnNewpad()
{
	Signal(2);	
}


/*************************************************************************
**************************************************************************
**																		**
**			Name:		 OnErase										**
**																		**
**			Parameters:  None  								   	        **
**																		**
**		    Description: Signals the Erase Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnErase()
{
	Signal(4);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name: OnRed													**
**																		**
**			Parameters: None  								   	        **
**																		**
**		    Description: Signals the Color Red Routine in HTBasic    	**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnRed()
{
	Signal(5);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name: OnBlue											    **
**																		**
**			Parameters: None  								   	        **
**																		**
**		    Description: Signals the Color Blue Routine in HTBasic		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnBlue()
{
	Signal(6);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name: OnYellow											    **
**																		**
**			Parameters: None  								   	        **
**																		**
**		    Description: Signals the Yellow Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnYellow()
{
	Signal(7);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name: OnPurple											    **
**																		**
**			Parameters: None  								   	        **
**																		**
**		    Description: Signals the Purple Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnPurple()
{
	Signal(8);
}


/*************************************************************************
**************************************************************************
**																		**
**			Name: OnWhite											    **
**																		**
**			Parameters: None  								   	        **
**																		**
**		    Description: Signals the White Routine in HTBasic    		**
**																		**
**																	    **
**************************************************************************
**************************************************************************/
void ToolBarDlg::OnWhite()
{
	Signal(9);
}
